<?php
class IndexAction extends CommonAction 
{
    public function index()
	{
		if($GLOBALS['weboff']==0)
		{
			header("Content-type:text/html;charset=utf-8");
			//检测管理员登陆
			$uname = cookie('uname');
			$uid = cookie('uid');
			if(empty($uname) or empty($uid))
			{
				
				die($GLOBALS['weboffmsg']);
			}

			if(session('cmsauth')<>substr(md5(strrev(cookie('uname')).'waikucms'.cookie('uid')),0,10))
			{
				die($GLOBALS['weboffmsg']);
			}
		}
		if($GLOBALS['rewrite']==0)
		{
			$arr = array_keys($_GET);
			if(count($arr)==1 && strlen($arr[0])>=1 && strlen($arr[0])<=11)
			{
				$this->jump($arr[0]);exit;
			}
		}
		//二维码功能
		if($GLOBALS['erweimaoff']==0)
		{
			$this->assign("erweima"," style='display:none'");
		}
		$this->display();
    }
	public function help()
	{
		$this->display();
    }
	public function create()
	{
		header('Content-type:text/json;charset=utf-8');
		$json = array();
		$url = rtrim(trim($_POST['url']),'/');
		//api保护
		if($GLOBALS['webapi']==0)
		{
			if(strcmp(trim($_GET['apicode']),'dwz'.$GLOBALS['webapicode'])<>0)
			{
				json_error('私有化api,禁止外部调用!');
			}
		}
		//功能开关判断
		if($GLOBALS['createoff']==0)
		{
			json_error('系统关闭了网址生成功能!');
		}
		if(strpos($url,'://')===false)
		{
			$url = 'http://'.$url; 
		}
		if(!preg_match('@^[a-z]+://((\w+(-\w+)*)(\.(\w+(-\w+)*))+)(\?\S*)?@',$url,$matches))
		{
			json_error('输入的网址不存在,请重新输入!');
		}
		else
		{	
			$url = strtr($url,$matches[0],strtolower($matches[0]));
			
		}
		//短网址安全联盟探测
		$dwzref = $this->dwzapi($url);
		if($dwzref)
		{
			json_error($dwzref);
		}
		//名单规则限制
		$predomain = strtolower($matches[1]);//域名
		preg_match('@^[a-z]+://(\S+)@',$url,$m2);
		$preallurl = $m2[1];// 全部网址部分
		$_whilerule = 0;
		if($GLOBALS['ruleoff']=='1')
		{
			//白名单
			$arr = explode('$',$GLOBALS['whiterule']);
			foreach($arr as $v)
			{
				$v = trim($v);
				//支持 *.匹配
				$ban = strtolower(substr($v,9));
				if(substr($v,0,9)=='domain:*.' && strpos($predomain,$ban)==true)
				{	
					$_whilerule = 1;
				}
				if(substr($v,0,7)=='domain:' && strtolower(substr($v,7))==$predomain)
				{
					$_whilerule = 1;
				}
			}
			if($_whilerule == 0)
			{
				json_error('当前地址不符合系统规则!');
			}
		}
		if($GLOBALS['ruleoff']=='2')
		{
			//黑名单
			$arr = explode("$",$GLOBALS['blackrule']);
			foreach($arr as $v)
			{
				$v = trim($v);
				//支持 *.匹配
				$ban = strtolower(substr($v,9));
				if(substr($v,0,9)=='domain:*.' && strpos($predomain,$ban)==true)
				{	
					json_error('当前地址不符合系统规则!');
				}
				if(substr($v,0,7)=='domain:' && strtolower(substr($v,7))==$predomain)
				{
					json_error('当前地址不符合系统规则!');
				}
				if(substr($v,0,4)=='url:' && strtolower(substr($v,4))== $preallurl)
				{
					json_error('当前地址不符合系统规则!');
				}
			}
		}
		if(!empty($_POST['alias']))
		{
			$model = M('alias');
			$data['longurl'] = $url;
			$list = $model->where($data)->find();
			if($list)
			{
				$json['tinyurl'] = getroot().'@'.$list['tinyurl'];
				$json['longurl'] = $list['longurl'];
				$json['status'] = -1;
				$json['err_msg']= '对不起,该网址已存在!';
				echo json_encode($json);exit;
			}
			$alias = trim($_POST['alias']);
			if(strlen($alias) > 10)
			{
				json_error('自定义字符最长支持10位,请重新输入!');
			}
			if(!preg_match('/^[a-zA-Z0-9]+$/',$alias))
			{
				json_error('对不起,自定义字符只能包含数字,大小写字母,请重新输入!');
			}
			if($model->where("id='".get_id($alias)."'")->find())
			{
				json_error('对不起,该短网址已被占用!');
			}
			else
			{
				$data['id'] = get_id($alias);
				$data['tinyurl'] = $alias;
				$data['addtime'] = time();
				//短地址加密选项
				if(!empty($_POST['pwd'])) $data['pwd'] = md5('%&@#*'.$_POST['pwd'].'dwz');
				if($model->add($data))
				{
					$json['tinyurl'] = getroot().'@'.$data['tinyurl'];
					$json['longurl'] = $data['longurl'];
					$json['status'] = 0;
					echo json_encode($json);exit;
				}
				else
				{
					json_error('内部错误,请重试!');
				}
			}
		}
		$model = M('info');
		$data['longurl'] = $url;
		$list = $model->where($data)->find();
		if($list)
		{
			$json['tinyurl'] = getroot().$list['tinyurl'];
			$json['longurl'] = $list['longurl'];
			$json['status'] = 0;
		}
		else
		{	

			$list2 = $model->field('id')->order('id desc')->limit('0,1')->find();
			$last_id = $list2['id']+1;
			//短地址加密选项
			if(!empty($_POST['pwd'])) $data2['pwd'] = md5('%&@#*'.$_POST['pwd'].'dwz');
			$data2['id'] = $last_id;
			$data2['longurl'] = $data['longurl'];
			$data = insert($model,$data2);
			$json['tinyurl'] = getroot().$data['tinyurl'];
			$json['longurl'] = $data['longurl'];
			$json['status'] = 0;
		}
		echo json_encode($json);exit;
	}
	
	public function query()
	{
		header('Content-type:text/json;charset=utf-8');
		$json = array();
		$url = trim($_POST['tinyurl']);
		//api保护
		if($GLOBALS['webapi']==0)
		{
			if(strcmp(trim($_GET['apicode']),'dwz'.$GLOBALS['webapicode'])<>0)
			{
				json_error('私有化api,禁止外部调用!');
			}
		}
		//功能开启判断
		if($GLOBALS['restoreoff']==0)
		{
			json_error('系统关闭了网址还原功能!');
		}
		if(strpos($url,'://')===false)
		{
			$url = 'http://'.$url; 
		}
		$url = str_replace(getroot(),'',$url);
		if(!preg_match('/^@?[a-zA-Z0-9]+$/',$url))
		{
			json_error('短网址不正确!','-2');
		}
		$data['tinyurl'] = $url;
		if(substr($url,0,1)=='@')
		{
			$model = M('alias');
			$data['tinyurl'] = trim($url,'@');
		}
		else
		{
			$model = M('info');
		}
		$list = $model->where($data)->find();
		if($list)
		{
			//加密网址不提供查询处理
			if(!empty($list['pwd']))
			{
				json_error('加密网址不能被还原!','-2');
			}
			$json['tinyurl'] = getroot().$list['tinyurl'];
			$json['longurl'] = $list['longurl'];
			$json['status'] = 0;
			echo json_encode($json);exit;
		}
		else
		{
			json_error('短网址不存在!','-2');
		}
	}
	public function jump($u='')
	{
		//第三方统计
		if($GLOBALS['thirdcountoff']==1)
		{
			$thirdcode = $GLOBALS['thirdcountcode'];
		}
		$data['tinyurl'] = trim($_GET['u']);
		if(!empty($u))
		{
			$data['tinyurl']  = $u;
		}
		if(empty($data['tinyurl'])) die("<script>window.location.href='".getroot(1)."'</script>");
		if(substr($data['tinyurl'],0,1)=='@')
		{
			$model = M('alias');
			$data['tinyurl'] = substr($data['tinyurl'],1);
			$this->assign('alias','@');
			$map['url'] = '@'.$data['tinyurl'];
		}
		else
		{
			$model = M('info');
			$map['url']  = $data['tinyurl'];
		}
		$list = $model->field('id,longurl,pwd')->where($data)->find();
		if(empty($list))
		{
			die("<script>window.location.href='".getroot(1)."'</script>");
		}
		else
		{
			//统计
			if($GLOBALS['visitcount']==1)
			{
				$map['visitip'] = get_client_ip();
				$map['visittime'] = time();
				$map['from'] = $_SERVER['HTTP_REFERER'];
				if(is_null($map['from'])) $map['from'] ='';
				$model2 = M('visit');
				$model2 ->add($map);
			}
			//地址加密
			if($GLOBALS['linkcodeoff']==1 && !empty($list['pwd']))
			{
				$this->assign('id',$list['id']);
				$this->display('pwd');exit;
			}
			die($thirdcode."<script>window.location.href='".$list['longurl']."'</script>");
		}
	}
	//输入密码访问
	public function pwd()
	{
		//第三方统计
		if($GLOBALS['thirdcountoff']==1)
		{
			$thirdcode = $GLOBALS['thirdcountcode'];
		}
		$data['id'] = $_POST['id'];
		$pwd =md5('%&@#*'.$_POST['pwd'].'dwz');
		if(empty($_POST['pwd']) or  empty($_POST['id'])) 
		{
				die("<script>window.location.href='".getroot(1)."'</script>");
		}
		if($_POST['alias'] =='@')
		{
			$model = M('alias');
		}
		else
		{
			$model = M('info');
		}
		$list = $model->where($data)->find();
		if(strcmp($list['pwd'],$pwd)==0)
		{
			die($thirdcode."<script>window.location.href='".$list['longurl']."'</script>");
		}
		else
		{
			alert('密码错误!',1);
		}
		
	}
	public function feedback()
	{
		if($GLOBALS['feedbackset']==0)
		{
			$this->error('站点反馈暂时关闭!',U('Index/index'));
		}
		$this->display();
	}
	public function dofeedback()
	{
		if(empty($_POST['verify'])) 
		{
			alert('请输入验证码!',1);
		}
		elseif(strtolower($_POST['verify']) <>$_SESSION['verify'])
		{
			alert('验证码不正确!',1);
		}
		$model = M('feedback');
		$data['title'] = trim($_POST['title']);
		$data['content'] = trim($_POST['content']);
		$data['addtime'] = time();
		if($model->add($data))
		{
			alert('感谢您的提议,我们会进一步以此改进!',__ROOT__);
		}
		else
		{
			alert('内部错误,请重试!',1);
		}
	}
	public function verify()
	{
		import("ORG.Verify");
		$verify = new Verify();
		$verify->display();
	}
	
	private function dwzapi($url='')
	{
		$ch=curl_init();
		curl_setopt($ch,CURLOPT_URL,"http://y01.cn/index.php?m=Api&a=safeurlapi&appkey=dwzse&appsecret=123456");
		curl_setopt($ch,CURLOPT_POST,true);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
		$data=array('url'=>$url);
		curl_setopt($ch,CURLOPT_POSTFIELDS,$data);
		$strRes=curl_exec($ch);
		curl_close($ch);
		$arrResponse = json_decode($strRes,true);
		if($arrResponse['status']<>0)
		{
			return $arrResponse['err_msg'];
		}
		else
		{
			return false;
		}
	}
}